(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: MRAVENEC.PAS                                                   *)
(*  Obsah: simulator "Langtonova mravence"                                 *)
(*  Autor: Mircosoft (http://mircosoft.mzf.cz)                             *)
(*  Posledni uprava: 13.8.2010                                             *)
(*  Pro kompilaci: VGA, KLAVESY, CAS                                       *)
(*  Pro spusteni: nic                                                      *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
{O co jde:
Jednoduchy matematicky model na tema deterministicky chaos, aneb kterak z
jednoduchych pravidel vznikaji slozite veci.

Mame kompletni, presny popis virtualniho sveta a zname pro nej univerzalni
teorii vseho.
Svet se sklada z nekonecne 2D ctvercove site policek (kazde policko muze byt
bud cerne nebo bile) a z "mravence", ktery muze po jednotlivych polickach
chodit (v ortogonalnich smerech).
Teorie vseho definuje dve jednoducha pravidla, podle kterych se mravenec
pohybuje:
- Pri slapnuti na bile policko zatoci doprava, pri slapnuti na cerne doleva.
- Kazdym slapnutim zmeni barvu policka z cerne na bilou nebo naopak.

Svet jednoduchy az primitivni. Cekali byste, ze mravenec bude chodit stale
dokolecka nebo v nejakem jednoduchem pravidelnem tvaru? Ne tak docela.
Pravidelne chodi jenom zpocatku, potom se zamota a docela dlouho beha zdanlive
naprosto chaoticky. Nakonec se ale chytne jednoho uhlopricneho smeru, zacykli
se a zacne stavet takovou nekonecnou "dalnici". Zajimave, ze?

Ovladani programu:
Stiskem libovolne klavesy spustite pohyb mravence. Shiftem ho muzete urychlit.
Konci se pri stisku libovolne klavesy nebo kdyz mravenec vybehne z obrazovky.}

program Langtonuv_mravenec;
uses vga,klavesy,cas; {lze nahradit jednotkami CRT a GRAPH}
const bila=7; cerna=0; {lze prenastavit dle vkusu}
type tsmer=(nahoru,doleva,dolu,doprava);
var x,y:integer; {poloha mravence}
    smer:tsmer; {smer pohybu mravence}
    pix:byte; {barva policka pod mravencem}
BEGIN
startvga;
vgafill(bila);
{mozna modifikace - trocha nahodneho sumu po okrajich:} {
randomize;
for x:=1 to 1000 do vgaputpixel(random(320),random(200),cerna);
vgabar(60,50,320-60,200-50,bila);{}
x:=160; y:=100; smer:=nahoru;
kcekej; kresetuj;
 repeat
 startcekani;
 pix:=_vgagetpixel(x,y);
 {na bilem policku mravenec zataci doprava, na cernem doleva:}
 if pix=bila then if smer=nahoru then smer:=doprava
                                 else dec(smer)
             else if smer=doprava then smer:=nahoru
                                  else inc(smer);
 {kazdym slapnutim meni mravenec barvu policka:}
 if pix=bila then _vgaputpixel(x,y,cerna)
             else _vgaputpixel(x,y,bila);
 {pohyb mravence:}
 case smer of nahoru:dec(y);
              doleva:dec(x);
              dolu:inc(y);
              doprava:inc(x);
              end;
 if not shiftpressed then pockej(10); {shiftem se pohyb urychli}
 until (x<0)or(x>319)or(y<0)or(y>199)or keypressed; {konec klavesou nebo opustenim obrazovky}
endvga;
END.